#include "header\gba.h"
#include "header\bg.h"
#include "header\timer.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "resource.h"
#include "resource\BGFont.h"
//#include "resource\BitMapFont.h"

//#include <string.h>
#include <stdlib.h>


//BG2 
//BG3 }bv
//---------------------------------------------------------------------------
#define MAX_ENEMY_CNT 5

#define MAX_MAP_CX 15
#define MAX_MAP_CY 15

#define MAP_CHIP_FLOOR  0	//STAGEϐpCHIPl
#define MAP_CHIP_WALL   1
#define MAP_CHIP_CHERRY 2
#define MAP_CHIP_PLAYER 3
#define MAP_CHIP_ENEMY  4

#define VECT_UP    0		//LN^̈ړ
#define VECT_DOWN  1
#define VECT_RIGHT 2
#define VECT_LEFT  3
#define VECT_NONE  4
//---------------------------------------------------------------------------
typedef struct {
	u8  x;
	u8  y;
	u8  cx;
	u8  cy;
	u8  Vect;		//ړ
	u16 SprNo;
	u16 SprTile;
	u16 SprSize;
	u16 SprForm;
}ST_CHR;

ST_CHR PLAYER;
ST_CHR ENEMY[MAX_ENEMY_CNT];

u8 Stage[MAX_MAP_CX][MAX_MAP_CY];
u8 StageCnt;
u8 StageLoadEndFlag;
u8 StageClearFlag;

u8 CherryCnt;		//Xe[WŎg`F[̐
u8 EnemyCnt;		//Xe[WŏoG̐

u8 CameraY;			//REG_BG3VOFSp

u8 BG2Chr;
u8 BG2Map;
u8 BG2Col;
u8 BG3Chr;
u8 BG3Map;
u8 BG3Col;

//---------------------------------------------------------------------------
void Init();
void InitChr();
void InitMap();
void LoadMap();
void SetMap();

void Input();
void Camera();

void ChkStageClear();
u8   ChkMoveUnit(ST_CHR* p);

void MoveProcess();
void MoveUnit(ST_CHR*);
void UnitEatCherry(ST_CHR* p);

void DrawUnit(ST_CHR* p);
void DrawWall(u8 x, u8 y);
void DrawFloor(u8 x, u8 y);
void DrawCherry(u8 x, u8 y);
void DrawStageClearMsg();
void DrawStageAllClearMsg();
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitMap();

	InitChr();
	LoadMap();
	SetMode(MODE_0 | BG2_ENABLE | BG3_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);

	while(StageLoadEndFlag != TRUE)
	{
		while(StageClearFlag != TRUE)
		{
			//1Xe[W̏
			WaitForVsync();

			Input();
			Camera();
			MoveProcess();
			//蔻
			
			ChkStageClear();
		}
		StageClearFlag = FALSE;

		//̃Xe[W
		DrawStageClearMsg();
		InitChr();
		LoadMap();
	}

	DrawStageAllClearMsg();
	for(;;){}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	//BG
	//BG2 
	//BG3 }bv
	BG2Chr = 1;
	BG2Map = 0;
	BG2Col = 0;

	BG3Chr = 2;
	BG3Map = 1;
	BG3Col = 1;

	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 0);
	REG_BG3CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG3Chr) | BG_MAPBASE(BG3Map) | 0);

	BGSetPal16  (BG2Col, (u16*)BGFont_palette);
	BGSetChrData(BG2Chr, (u16*)BGFont_data, BGFont_DATA_SIZE);
	BGSetPal16  (BG3Col, (u16*)&game_spr_pal_bin);
	BGSetChrData(BG3Chr, (u16*)&game_spr_img_bin, 2048);

	//Sprite
	SpriteInit();
	SpriteSetPal16((u16*)&game_spr_pal_bin);
	SpriteSetData ((u16*)&game_spr_img_bin, 2048);
}
//---------------------------------------------------------------------------
void InitChr()
{
	//PLAYER
	PLAYER.x       = 240;
	PLAYER.y       = 160;
	PLAYER.cx      = 16;
	PLAYER.cy      = 16;
	PLAYER.Vect    = VECT_NONE;
	PLAYER.SprNo   = 0;
	PLAYER.SprTile = 2;
	PLAYER.SprSize = SP_SIZE_16;
	PLAYER.SprForm = SP_SQUARE;
	
	SpriteSetSize(PLAYER.SprNo, PLAYER.SprSize, PLAYER.SprForm, SP_COLOR_16);
	SpriteSetChr (PLAYER.SprNo, PLAYER.SprTile);

	//ENEMY
	EnemyCnt=0;
	u8 i;
	for(i=0; i<MAX_ENEMY_CNT; i++)
	{
		ENEMY[i].x       = 240;
		ENEMY[i].y       = 160;
		ENEMY[i].cx      = 16;
		ENEMY[i].cy      = 16;
		ENEMY[i].Vect    = rand() % 4;
		ENEMY[i].SprNo   = i+1;
		ENEMY[i].SprTile = 4;
		ENEMY[i].SprSize = SP_SIZE_16;
		ENEMY[i].SprForm = SP_SQUARE;
		
		SpriteSetSize(ENEMY[i].SprNo, ENEMY[i].SprSize, ENEMY[i].SprForm, SP_COLOR_16);
		SpriteSetChr (ENEMY[i].SprNo, ENEMY[i].SprTile);
	}
}
//---------------------------------------------------------------------------
void InitMap()
{
	StageCnt = 0;
	StageLoadEndFlag = FALSE;
	
	SeekSetChr((u8*)&game_map_bin, 1066, ';');
}
//---------------------------------------------------------------------------
void LoadMap()
{
	if(SeekHasMore() != TRUE)
	{
		//ǂݍރXe[WȂȂ
		StageLoadEndFlag = TRUE;
		return;
	}

	u8* pMapData = SeekNext() + 6;	//6̓AhXʒu̕␳
	u8  x=0,y=0;
	while(y < MAX_MAP_CY)
	{
		Stage[x++][y] = *pMapData++ - '0';

		if(*pMapData == 0x0d)	//sR[h̏ꍇ
		{
			x=0; y++;
			pMapData+=2;
		}
	}

	SetMap();
}
//---------------------------------------------------------------------------
void SetMap()
{
	StageClearFlag = FALSE;
	StageCnt++;

	CherryCnt   = 0;
	EnemyCnt    = 0;
	CameraY     = 0;
	REG_BG3VOFS = 0;

	u8 x, y;
	for(y=0; y<MAX_MAP_CY; y++)
	{
		for(x=0; x<MAX_MAP_CX; x++)
		{
			switch(Stage[x][y])
			{
			case MAP_CHIP_PLAYER:
				PLAYER.x = x*16;
				PLAYER.y = y*16;
				DrawUnit(&PLAYER);
				DrawFloor (x*2, y*2);
				break;
			case MAP_CHIP_ENEMY:
				ENEMY[EnemyCnt].x = x*16;
				ENEMY[EnemyCnt].y = y*16;
				DrawUnit(&ENEMY[EnemyCnt]);
				EnemyCnt++;
				DrawFloor (x*2, y*2);
				break;

			case MAP_CHIP_FLOOR:  DrawFloor (x*2, y*2); break;
			case MAP_CHIP_WALL:   DrawWall  (x*2, y*2); break;
			case MAP_CHIP_CHERRY: DrawCherry(x*2, y*2); CherryCnt++; break;
			default: break;
			}
		}
	}
}
//---------------------------------------------------------------------------
void ChkStageClear()
{
	if(CherryCnt > 0)
	{
		return;
	}
	StageClearFlag=TRUE;
}
//---------------------------------------------------------------------------
void Input()
{
	KeyInit();
	u8 Key  = KeyInput();
	u8 vect = PLAYER.Vect;

	if(Key & KEY_UP   ) PLAYER.Vect = VECT_UP;
	if(Key & KEY_DOWN ) PLAYER.Vect = VECT_DOWN;
	if(Key & KEY_LEFT ) PLAYER.Vect = VECT_LEFT;
	if(Key & KEY_RIGHT) PLAYER.Vect = VECT_RIGHT;

	if( ChkMoveUnit(&PLAYER) != TRUE )
	{
		PLAYER.Vect = vect;
	}
}
//---------------------------------------------------------------------------
//ړ
void MoveProcess()
{
	//vC
	if(PLAYER.Vect != VECT_NONE)
	{
		if( ChkMoveUnit(&PLAYER) == TRUE )
		{
			MoveUnit(&PLAYER);
			UnitEatCherry(&PLAYER);
		}
	}


	//G
	u8 i;
	for(i=0; i<EnemyCnt; i++)
	{
		if( ChkMoveUnit(&ENEMY[i]) == TRUE )
		{
			MoveUnit(&ENEMY[i]);
		}
		else
		{	//ړ悪ǂ̏ꍇ́Aړ_Ō
			ENEMY[i].Vect = rand() % 4;
		}
	}
}
//---------------------------------------------------------------------------
//ړ͈ړ\`FbN
u8 ChkMoveUnit(ST_CHR* p)
{
	u8 VectQuantity[5][5] = { {0,-1},{0,1},{1,0},{-1,0},{0,0} };

	//pSԂ
	u8 x1 = p->x + VectQuantity[p->Vect][0];
	u8 y1 = p->y + VectQuantity[p->Vect][1];
	u8 x2 = x1 + p->cx -1;
	u8 y2 = y1 + p->cy -1;
	u8 x3 = x2;
	u8 y3 = y1;
	u8 x4 = x1;
	u8 y4 = y2;
	
	//fBXvCWStageϐpɕϊ
	x1 = x1 / 16;
	y1 = y1 / 16;
	x2 = x2 / 16;
	y2 = y2 / 16;
	x3 = x3 / 16;
	y3 = y3 / 16;
	x4 = x4 / 16;
	y4 = y4 / 16;

	if(   Stage[x1][y1] == MAP_CHIP_WALL
	   || Stage[x2][y2] == MAP_CHIP_WALL
	   || Stage[x3][y3] == MAP_CHIP_WALL
	   || Stage[x4][y4] == MAP_CHIP_WALL)
	{
		return FALSE;
	}

	return TRUE;
}
//---------------------------------------------------------------------------
//ړ
void MoveUnit(ST_CHR* p)
{
	u8 VectQuantity[5][5] = { {0,-1},{0,1},{1,0},{-1,0},{0,0} };

	p->x += VectQuantity[p->Vect][0];
	p->y += VectQuantity[p->Vect][1];
	DrawUnit(p);
}
//---------------------------------------------------------------------------
void UnitEatCherry(ST_CHR* p)
{
	u8 x = (p->x + p->cx/2) / 16;
	u8 y = (p->y + p->cy/2) / 16;

	if(Stage[x][y] == MAP_CHIP_CHERRY)
	{
		Stage[x][y] = MAP_CHIP_FLOOR;
		CherryCnt--;
		DrawFloor(x*2, y*2);
	}
}
//---------------------------------------------------------------------------
void DrawWall(u8 x, u8 y)
{
	BGDrawChar(BG3Map, x+0, y+0, BG3Col, 0x06);
	BGDrawChar(BG3Map, x+1, y+0, BG3Col, 0x07);
	BGDrawChar(BG3Map, x+0, y+1, BG3Col, 0x26);
	BGDrawChar(BG3Map, x+1, y+1, BG3Col, 0x27);
}
//---------------------------------------------------------------------------
void DrawFloor(u8 x, u8 y)
{
	BGDrawChar(BG3Map, x+0, y+0, BG3Col, 0x00);
	BGDrawChar(BG3Map, x+1, y+0, BG3Col, 0x01);
	BGDrawChar(BG3Map, x+0, y+1, BG3Col, 0x20);
	BGDrawChar(BG3Map, x+1, y+1, BG3Col, 0x21);
}
//---------------------------------------------------------------------------
void DrawCherry(u8 x, u8 y)
{
	BGDrawChar(BG3Map, x+0, y+0, BG3Col, 0x08);
	BGDrawChar(BG3Map, x+1, y+0, BG3Col, 0x09);
	BGDrawChar(BG3Map, x+0, y+1, BG3Col, 0x28);
	BGDrawChar(BG3Map, x+1, y+1, BG3Col, 0x29);
}
//---------------------------------------------------------------------------
void DrawStageClearMsg()
{
	char msg[40];
	bprintf(msg, "Stage%d Clear!", StageCnt);
	BGDrawStr(BG2Map, 8, 10, (u8*)msg);

	WaitKey(KEY_A);
	BGDrawCls(BG2Map, 0x0000);
}
//---------------------------------------------------------------------------
void DrawStageAllClearMsg()
{
	char msg[40];
	bprintf(msg, "Stage ALL Clear!");
	BGDrawStr(BG2Map, 8, 10, (u8*)msg);

	WaitKey(KEY_A);
}
//---------------------------------------------------------------------------
void Camera()
{
	if(PLAYER.y == 120)
	{
		REG_BG3VOFS = 80;
		CameraY     = 80;
	}
	if(PLAYER.y == 108)
	{
		REG_BG3VOFS = 0;
		CameraY     = 0;
	}
}
//---------------------------------------------------------------------------
void DrawUnit(ST_CHR* p)
{
	SpriteMove(p->SprNo, p->x, p->y - CameraY);
}
